<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Task72.40</title>
  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback" />
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
  <!-- DataTables -->
  <link rel="stylesheet" href="plugins/datatables-bs4/css/dataTables.bootstrap4.min.css" />
  <link rel="stylesheet" href="plugins/datatables-responsive/css/responsive.bootstrap4.min.css" />
  <link rel="stylesheet" href="plugins/datatables-buttons/css/buttons.bootstrap4.min.css" />
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css" />
  <style>
    i {
      cursor: pointer;
    }
  </style>
</head>

<body>
  <div class="wrapper">
  
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search"
                  aria-label="Search" />
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->
    <!-- Main Sidebar Container -->
    <aside style="min-height: 100vh;" class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="info">
          <a href="#" class="d-block text-center">DEV CAMP</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-th"></i>
              <p>
                Manage
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="voucher.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Voucher</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="menu.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menu</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="drink.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drink</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="region.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Region</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="order.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Order</p>
                </a>
              </li>
            </ul>
          </li>
          <!--  -->
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
  </div>
  <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Menu</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Menu</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <h3 class="text-center text-primary">Quản trị menu</h3>
        <div class="jumbotron container">
            <div class="row form-group">
                <label for="" class="col-sm-3">Kích cỡ</label>
                <div class="col-sm-9">
                    <input id="inp-kich-co" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Đường kính</label>
                <div class="col-sm-9">
                    <input id="inp-duong-kinh" type="number" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Sườn</label>
                <div class="col-sm-9">
                    <input id="inp-suon" type="number" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Salad</label>
                <div class="col-sm-9">
                    <input id="inp-salad" type="number" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Số lượng nước</label>
                <div class="col-sm-9">
                    <input id="inp-so-luong-nuoc" type="number" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Thành tiền</label>
                <div class="col-sm-9">
                    <input id="inp-thanh-tien" type="number" class="form-control">
                </div>
            </div>

            
            <button id="btn-add" class="btn btn-success">Thêm mới</button>
            <button id="btn-update" class="btn btn-primary" style="display: none;">Cập nhật</button>
            <button id="btn-delete" class="btn btn-danger" style="display: none;">Xóa Menu</button>

        </div>

        <table id="table-menus" class="table table-bordered table-stripped table-hover">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Kích cỡ</th>
                    <th>Đường kính</th>
                    <th>Sườn</th>
                    <th>Salad</th>
                    <th>Số lượng nước</th>
                    <th>Thành tiền</th>
                </tr>
            </thead>
            <tbody></tbody>
        </table>
    </div>
    </section>
    <!-- /.content -->
    <!-- /.content-wrapper -->
  </div>
  </div>
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.1.0
    </div>
  </footer>
  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- jQuery UI 1.11.4 -->
  <script src="plugins/jquery-ui/jquery-ui.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- DataTables  & Plugins -->
  <script src="plugins/datatables/jquery.dataTables.min.js"></script>
  <script src="plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.js"></script>
  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */  
    var gTableMenus = $("#table-menus").DataTable({
        columns: [
            { data: "id"},
            { data: "kichCo"},
            { data: "duongKinh"},
            { data: "suon"},
            { data: "salad"},
            { data: "soLuongNuoc"},
            { data: "thanhTien"}
        ],
        columnDefs: [
            {
                targets: 0,
                render: function() {
                    return gStt++;
                }
            }
        ]
    });
  
    var gStt = 1;
    var gMenuId = null;
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();
  
    // Thực thi sự kiện nhấn vào row trong datatable
    $("#table-menus").on("click", "tr", function() {
        onClickRowMenu(this);
    });
  
    // Thực thi sự kiện nhấn nút tạo mới menu 
    $("#btn-add").on("click", function(){
        onBtnAddNewClick();
    });
  
    // Thực thi sự kiện nhấn nút cập nhật menu 
    $("#btn-update").on("click", function(){
        onBtnUpdateClick();
    });
  
    // Thực thi sự kiện nhấn nút xóa menu 
    $("#btn-delete").on("click", function(){
        $("#modal-delete").modal("show");
    });
  
    // Thực thi sự kiện xác nhận xóa trong modal delete
    $("#btn-confirm").on("click", function() {
        onBtnDeleteClick();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        callApiToLoadListMenu();
    }
  
    // Hàm sự kiện nhấn vào row menu
    function onClickRowMenu(paramRow) {
        var vDataRow = gTableMenus.row(paramRow).data();
        $("#inp-kich-co").val(vDataRow.kichCo);
        $("#inp-duong-kinh").prop("value", vDataRow.duongKinh);
        $("#inp-suon").val(vDataRow.suon);
        $("#inp-salad").val(vDataRow.salad);
        $("#inp-so-luong-nuoc").val(vDataRow.soLuongNuoc);
        $("#inp-thanh-tien").val(vDataRow.thanhTien);
  
        $("#btn-add").hide();
        $("#btn-update").show();
        $("#btn-delete").show();
        gMenuId = vDataRow.id;
    }
  
    // Hàm xử lý sự kiện nhấn nút thêm mới menu
    function onBtnAddNewClick() {
        var vMenu = {
            kichCo : "",
            duongKinh : "",
            suon : "",
            salad : "",
            soLuongNuoc : "",
            thanhTien : ""
        }
  
        getData(vMenu);
        var vValidate = validateData(vMenu);
        if(vValidate) {
            callApiToCreateNew(vMenu);
        }
    }
  
    // Hàm xử lý sự kiện nhấn nút sửa 1 menu
    function onBtnUpdateClick() {
        var vMenu = {
            kichCo : "",
            duongKinh : "",
            suon : "",
            salad : "",
            soLuongNuoc : "",
            thanhTien : ""
        }
  
        getData(vMenu);
        var vValidate = validateData(vMenu);
        if(vValidate) {
            callApiToUpdate(vMenu);
        }
    }
  
    // Hàm nhấn nút delete menu
    function onBtnDeleteClick() {
        $.ajax({
            type: "DELETE",
            url: "http://localhost:8080/menu/" + gMenuId,
            success: function(paramRes) {
                alert("Menu đã bị xóa!");
                callApiToLoadListMenu();
                resetForm();
                $("#modal-delete").modal("hide");
            },
            error: function(paramError) {
                console.log(paramError.status);
                alert("Xóa menu thất bại, vui lòng thử lại!");
                $("#modal-delete").modal("hide");
            }
        })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  
    // Hàm gọi APi để load dữ liệu menu vào table
    function callApiToLoadListMenu() {
        $.ajax({
            type: "GET",
            url: "http://localhost:8080/menus",
            success: function(paramRes) {
                console.log(paramRes);
                loadDataToTable(paramRes);
            },
            error: function(paramError) {
                console.log(paramError.status);
            }
        });
    }
  
    // Hàm load dữ liệu vào table
    function loadDataToTable(paramMenuData) {
        gStt = 1;
        gTableMenus.clear();
        gTableMenus.rows.add(paramMenuData);
        gTableMenus.draw();
    }
  
    // Hàm format lại ngày tháng
    function formatDate(paramDate) {
        var vDate = paramDate.split("-");
        return vDate[2]+ "-" + vDate[1] + "-" + vDate[0];
    }
  
    // Hàm lấy dữ liệu từ form
    function getData(paramData) {
        paramData.kichCo = $("#inp-kich-co").val();
        paramData.duongKinh = $("#inp-duong-kinh").val();
        paramData.suon = $("#inp-suon").val();
        paramData.salad = $("#inp-salad").val();
        paramData.soLuongNuoc = $("#inp-so-luong-nuoc").val();
        paramData.thanhTien = $("#inp-thanh-tien").val();
  
    }
  
    // Hàm validate dữ liệu
    function validateData(paramData) {
        if(paramData.kichCo == "") {
            alert("Vui lòng nhập kích cỡ!");
            return false;
        }
        if(paramData.duongKinh == "") {
            alert("Nhập đường kính");
            return false;
        }
        
        if(paramData.suon == "") {
            alert("Nhập số lượng sườn");
            return false;
        }
  
        if(paramData.salad == "") {
            alert("Nhập lượng salad");
            return false;
        }
  
        if(paramData.soLuongNuoc == "") {
            alert("Nhập số lượng nước");
            return false;
        }
  
        if(paramData.thanhTien == "") {
            alert("Nhập giá tiền");
            return false;
        }
        return true;
    }
  
    // Hàm gọi api để thêm mới menu  
    function callApiToCreateNew(paramData) {
        $.ajax({
            type: "POST",
            url: "http://localhost:8080/menus",
            contentType: "application/json",
            data: JSON.stringify(paramData),
            success: function(paramRes) {
                alert("Tạo mới menu thành công!");
                resetForm();
                callApiToLoadListMenu();
            }, 
            error: function(paramError) {
                console.log(paramError.status);
            }
        });
    }
  
    // Hàm reset form menu
    function resetForm() {
        $("#inp-kich-co").val("");
        $("#inp-duong-kinh").val("");
        $("#inp-suon").val("");
        $("#inp-salad").val("");
        $("#inp-so-luong-nuoc").val("");
        $("#inp-thanh-tien").val("");
  
        $("#btn-add").show();
        $("#btn-update").hide();
        $("#btn-delete").hide();
    }
  
    // Hàm gọi API để sửa 1 menu
    function callApiToUpdate(paramData) {
        $.ajax({
            type: "PUT",
            url: "http://localhost:8080/menu/" + gMenuId,
            contentType: "application/json",
            data: JSON.stringify(paramData),
            success: function(paramRes) {
                alert("Cập nhật thành công!");
                resetForm();
                callApiToLoadListMenu();
            }, 
            error: function(paramError) {
                console.log(paramError.status);
            }
        });
    }
  
  
  </script>
</body>

</html>